/* Help categories*/
#define CLIENT_CAT_STR "Client"
#define MESSAGE_CAT_STR "Message"
#define USER_CAT_STR "User"
#define ACCOUNT_CAT_STR "Account"

/* Help strings for each command */
#define PASS_HELP_STR "\t\tChanges your password to secret.\n"
#define MSG_HELP_STR "\t\tSends a message to uin\n"
#define URL_HELP_STR "\tSends a url and message to uin\n"
#define MSGA_HELP_STR "\tSends a multiline message to everyone on your list.\n"
#define AGAIN_HELP_STR "\t\tSends a message to the last person you sent a message to\n"
#define AUTH_HELP_STR "\t\tAuthorize uin to add you to their list\n"
#define REPLY_HELP_STR "\t\tReplys to the last person to send you a message\n"
#define RAND_HELP_STR "\t\tFinds a random user in the specified group or lists the groups.\n"
#define LIST_HELP_STR "\t\t\tDisplays the current status of everyone on your contact list\n"
#define ALTER_HELP_STR "\tThis command allows you to alter your command set on the fly.\n"
#define VERBOSE_HELP_STR "\t\t\tSet the verbosity level ( default = 0 ).\n"
#define CLEAR_HELP_STR "\t\t\t\tClears the screen.\n"
#define SOUND_HELP_STR "\t\t\t\tToggles beeping when recieving new messages.\n"
#define COLOR_HELP_STR "\t\t\t\tToggles displaying colors.\n"
#define QUIT_HELP_STR "\t\t\tLogs off and quits\n"
#define AUTO1_HELP_STR "\t\t\t\tDisplays your autoreply status\n"
#define AUTO2_HELP_STR "\t\t\tToggles sending messages when your status is DND, NA, etc.\n"
#define AUTO3_HELP_STR "\t\tSets the message to send as an auto reply for the status\n"
#define REG_HELP_STR "\tCreates a new UIN with the specified password.\n"
#define CHANGE_HELP_STR "\tChanges your status to the status number.\n\t\tWithout a number it lists the available modes.\n"
#define ADD_HELP_STR "\tAdds the uin number to your contact list with nickname.\n"
#define SEARCH_HELP_STR "\tSearches for a ICQ user with the specified email address.\n"
#define INFO_HELP_STR "\t\tDisplays general info on uin\n"
#define ONLINE_HELP_STR "\t\tMark as Online.\n"
#define AWAY_HELP_STR "\t\tMark as Away.\n"
#define NA_HELP_STR "\t\tMark as Not Available.\n"
#define OCC_HELP_STR "\t\tMark as Occupied.\n"
#define DND_HELP_STR "\t\tMark as Do not Disturb.\n"
#define FFC_HELP_STR "\t\tMark as Free for Chat.\n"
#define INV_HELP_STR "\t\tMark as Invisible.\n"
#define UPDATE_HELP_STR "\t\tUpdates your basic info (email, nickname, etc.)\n"
#define SET_RAND_HELP_STR "\t\tSets your random user group.\n"

#define VERBOSE_LEVEL_STR "Verbosity level is %d.\n"
#define NICK_NOT_FOUND_STR "%s not recognized as a nick name"

/* Used in the "w" user display */
#define W_ONLINE_SINCE_STR " Online since %s"
#define W_LAST_ONLINE_STR " Last online at %s"
#define W_LAST_ON_UNKNOWN_STR " Last on-line unknown."
#define W_STATUS_STR "Your status is "
#define W_OFFLINE_STR "Users offline: "
#define W_ONLINE_STR "Users online: "

#define MSG_PROMPT_STR "msg> "
#define MSGA_PROMPT_STR "msg all> "

/* These are used durring user info updates. */
#define NICK_NAME_UPDATE_STR "Enter Your New Nickname : "
#define FIRST_NAME_UPDATE_STR "Enter Your New First Name : "
#define LAST_NAME_UPDATE_STR "Enter Your New Last Name : "
#define EMAIL_UPDATE_STR "Enter Your New Email Address : "
#define AUTH_QUESTION_STR "Do you want to require Mirabilis users to request your authorization? : "

#define YESNO_RESPONSE_STR "Please enter " YES_STR " or " NO_STR "\n"
#define MESSAGE_BUFFER_FULL_STR "Message sent before last line buffer is full\n"
#define MESSAGE_CANCELED_STR "Message canceled\n"
/* Having 2 strings with the nickname inserted in the middle */
/* will hopefully solve any potential word order problems */
#define MESSAGE_SENT_1_STR  "Message sent to "
#define MESSAGE_SENT_2_STR  "!\n"

/********************************************************************/
/* Simple Yes no response*/
#define YES_STR "YES"
#define NO_STR "NO"

/* The promt used by Micq */
#define PROMPT_STR SERVCOL "Micq> " NOCOL

/* The different status modes */
#define STATUS_ONLINE_STR "Online"
#define STATUS_DND_STR "Do not disturb"
#define STATUS_AWAY_STR "Away"
#define STATUS_NA_STR "Not Available"
#define STATUS_OCCUPIED_STR "Occupied"
#define STATUS_INVISIBLE_STR "Invisible"
#define STATUS_FFC_STR "Free for chat"

/* results of searches */
#define ALL_FOUND_STR "All users found."
#define TOO_MANY_STR "Too many users found."
#define SEARCH_DONE_STR "Search Done."

/* Strings for help screen */
#define SELECT_GROUP_STR "Please select one of the help topics below."
#define CLIENT_HELP_STR "Commands relating to micq displays and configuration."
#define USER_HELP_STR "Commands relating to finding other users."
#define ACCOUNT_HELP_STR "Commands relating to your ICQ account."
#define MESSAGE_HELP_STR "Commands relating to sending messages."

/* Various Strings */
#define LENGTH_STR "Length"
#define EXTRA_DATA_STR "Extra Data"
#define SEQ_STR "SEQ"
#define VER_STR "Ver"
#define LOGIN_SUCCESS_STR "Login successful!"
#define SERVER_ACK_STR "The server acknowledged the %04x command."

/* The Countries there's alot */
#define USA_COUNTRY_STR "USA"
#define Afghanistan_COUNTRY_STR (const char*) "Afghanistan"
#define Albania_COUNTRY_STR "Albania"
#define Algeria_COUNTRY_STR "Algeria"
#define American_Samoa_COUNTRY_STR "American Samoa"
#define Andorra_COUNTRY_STR "Andorra"
#define Angola_COUNTRY_STR "Angola"
#define Anguilla_COUNTRY_STR "Anguilla"
#define Antigua_COUNTRY_STR "Antigua"
#define Argentina_COUNTRY_STR "Argentina"
#define Armenia_COUNTRY_STR "Armenia"
#define Aruba_COUNTRY_STR "Aruba"
#define Ascention_Island_COUNTRY_STR "Ascention Island"
#define Australia_COUNTRY_STR "Australia"
#define Australian_Antartic_Territory_COUNTRY_STR "Australian Antartic Territory"
#define Austria_COUNTRY_STR "Austria"
#define Azerbaijan_COUNTRY_STR "Azerbaijan"
#define Bahamas_COUNTRY_STR "Bahamas"
#define Bahrain_COUNTRY_STR "Bahrain"
#define Bangladesh_COUNTRY_STR "Bangladesh"
#define Barbados_COUNTRY_STR "Barbados"
#define Belarus_COUNTRY_STR "Belarus"
#define Belgium_COUNTRY_STR "Belgium"
#define Belize_COUNTRY_STR "Belize"
#define Benin_COUNTRY_STR "Benin"
#define Bermuda_COUNTRY_STR "Bermuda"
#define Bhutan_COUNTRY_STR "Bhutan"
#define Bolivia_COUNTRY_STR "Bolivia"
#define Bosnia_Herzegovina_COUNTRY_STR "Bosnia & Herzegovina"
#define Botswana_COUNTRY_STR "Botswana"
#define Brazil_COUNTRY_STR "Brazil"
#define British_Virgin_Islands_COUNTRY_STR "British Virgin Islands"
#define Brunei_COUNTRY_STR "Brunei"
#define Bulgaria_COUNTRY_STR "Bulgaria"
#define Burkina_Faso_COUNTRY_STR "Burkina Faso"
#define Burundi_COUNTRY_STR "Burundi"
#define Cambodia_COUNTRY_STR "Cambodia"
#define Cameroon_COUNTRY_STR "Cameroon"
#define Canada_COUNTRY_STR "Canada"
#define Cape_Verde_Islands_COUNTRY_STR "Cape Verde Islands"
#define Cayman_Islands_COUNTRY_STR "Cayman Islands"
#define Central_African_Republic_COUNTRY_STR "Central African Republic"
#define Chad_COUNTRY_STR "Chad"
#define Christmas_Island_COUNTRY_STR "Christmas Island"
#define Cocos_Keeling_Islands_COUNTRY_STR "Cocos-Keeling Islands"
#define Comoros_COUNTRY_STR "Comoros"
#define Congo_COUNTRY_STR "Congo"
#define Cook_Islands_COUNTRY_STR "Cook Islands"
#define Chile_COUNTRY_STR "Chile"
#define China_COUNTRY_STR "China"
#define Columbia_COUNTRY_STR "Columbia"
#define Costa_Rice_COUNTRY_STR "Costa Rice"
#define Croatia_COUNTRY_STR "Croatia"
#define Cuba_COUNTRY_STR "Cuba"
#define Cyprus_COUNTRY_STR "Cyprus"
#define Czech_Republic_COUNTRY_STR "Czech Republic"
#define Denmark_COUNTRY_STR "Denmark"
#define Diego_Garcia_COUNTRY_STR "Diego Garcia"
#define Djibouti_COUNTRY_STR "Djibouti"
#define Dominica_COUNTRY_STR "Dominica"
#define Dominican_Republic_COUNTRY_STR "Dominican Republic"
#define Ecuador_COUNTRY_STR "Ecuador"
#define Egypt_COUNTRY_STR "Egypt"
#define El_Salvador_COUNTRY_STR "El Salvador"
#define Equitorial_Guinea_COUNTRY_STR "Equitorial Guinea"
#define Eritrea_COUNTRY_STR "Eritrea"
#define Estonia_COUNTRY_STR "Estonia"
#define Ethiopia_COUNTRY_STR "Ethiopia"
#define Former_Yugoslavia_COUNTRY_STR "F.Y.R.O.M. (Former Yugoslavia)"
#define Faeroe_Islands_COUNTRY_STR "Faeroe Islands"
#define Falkland_Islands_COUNTRY_STR "Falkland Islands"
#define Federated_States_of_Micronesia_COUNTRY_STR "Federated States of Micronesia"
#define Fiji_COUNTRY_STR "Fiji"
#define Finland_COUNTRY_STR "Finland"
#define France_COUNTRY_STR "France"
#define French_Antilles_COUNTRY_STR "French Antilles"
#define French_Guiana_COUNTRY_STR "French Guiana"
#define French_Polynesia_COUNTRY_STR "French Polynesia"
#define Gabon_COUNTRY_STR "Gabon"
#define Gambia_COUNTRY_STR "Gambia"
#define Georgia_COUNTRY_STR "Georgia"
#define Germany_COUNTRY_STR "Germany"
#define Ghana_COUNTRY_STR "Ghana"
#define Gibraltar_COUNTRY_STR "Gibraltar"
#define Greece_COUNTRY_STR "Greece"
#define Greenland_COUNTRY_STR "Greenland"
#define Grenada_COUNTRY_STR "Grenada"
#define Guadeloupe_COUNTRY_STR "Guadeloupe"
#define Guam_COUNTRY_STR "Guam"
#define Guantanomo_Bay_COUNTRY_STR "Guantanomo Bay"
#define Guatemala_COUNTRY_STR "Guatemala"
#define Guinea_COUNTRY_STR "Guinea"
#define Guinea_Bissau_COUNTRY_STR "Guinea-Bissau"
#define Guyana_COUNTRY_STR "Guyana"
#define Haiti_COUNTRY_STR "Haiti"
#define Honduras_COUNTRY_STR "Honduras"
#define Hong_Kong_COUNTRY_STR "Hong Kong"
#define Hungary_COUNTRY_STR "Hungary"
#define Iceland_COUNTRY_STR "Iceland"
#define India_COUNTRY_STR "India"
#define Indonesia_COUNTRY_STR "Indonesia"
#define INMARSAT_COUNTRY_STR "INMARSAT"
#define INMARSAT_Atlantic_East_COUNTRY_STR "INMARSAT Atlantic-East"
#define Iran_COUNTRY_STR "Iran"
#define Iraq_COUNTRY_STR "Iraq"
#define Ireland_COUNTRY_STR "Ireland"
#define Israel_COUNTRY_STR "Israel"
#define Italy_COUNTRY_STR "Italy"
#define Ivory_Coast_COUNTRY_STR "Ivory Coast"
#define Japan_COUNTRY_STR "Japan"
#define Jordan_COUNTRY_STR "Jordan"
#define Kenya_COUNTRY_STR "Kenya"
#define South_Korea_COUNTRY_STR "South Korea"
#define Kuwait_COUNTRY_STR "Kuwait"
#define Liberia_COUNTRY_STR "Liberia"
#define Libya_COUNTRY_STR "Libya"
#define Liechtenstein_COUNTRY_STR "Liechtenstein"
#define Luxembourg_COUNTRY_STR "Luxembourg"
#define Malawi_COUNTRY_STR "Malawi"
#define Malaysia_COUNTRY_STR "Malaysia"
#define Mali_COUNTRY_STR "Mali"
#define Malta_COUNTRY_STR "Malta"
#define Mexico_COUNTRY_STR "Mexico"
#define Monaco_COUNTRY_STR "Monaco"
#define Morocco_COUNTRY_STR "Morocco"
#define Namibia_COUNTRY_STR "Namibia"
#define Nepal_COUNTRY_STR "Nepal"
#define Netherlands_COUNTRY_STR "Netherlands"
#define Netherlands_Antilles_COUNTRY_STR "Netherlands Antilles"
#define New_Caledonia_COUNTRY_STR "New Caledonia"
#define New_Zealand_COUNTRY_STR "New Zealand"
#define Nicaragua_COUNTRY_STR "Nicaragua"
#define Nigeria_COUNTRY_STR "Nigeria"
#define Norway_COUNTRY_STR "Norway"
#define Oman_COUNTRY_STR "Oman"
#define Pakistan_COUNTRY_STR "Pakistan"
#define Panama_COUNTRY_STR "Panama"
#define Papua_New_Guinea_COUNTRY_STR "Papua New Guinea"
#define Paraguay_COUNTRY_STR "Paraguay"
#define Peru_COUNTRY_STR "Peru"
#define Philippines_COUNTRY_STR "Philippines"
#define Poland_COUNTRY_STR "Poland"
#define Portugal_COUNTRY_STR "Portugal"
#define Qatar_COUNTRY_STR "Qatar"
#define Romania_COUNTRY_STR "Romania"
#define Russia_COUNTRY_STR "Russia"
#define Saipan_COUNTRY_STR "Saipan"
#define San_Marino_COUNTRY_STR "San Marino"
#define Saudia_Arabia_COUNTRY_STR "Saudia Arabia"
#define Senegal_COUNTRY_STR "Senegal"
#define Singapore_COUNTRY_STR "Singapore"
#define Slovakia_COUNTRY_STR "Slovakia"
#define South_Africa_COUNTRY_STR "South Africa"
#define Spain_COUNTRY_STR "Spain"
#define Sri_Lanka_COUNTRY_STR "Sri Lanka"
#define Suriname_COUNTRY_STR "Suriname"
#define Sweden_COUNTRY_STR "Sweden"
#define Switzerland_COUNTRY_STR "Switzerland"
#define Taiwan_COUNTRY_STR "Taiwan"
#define Tanzania_COUNTRY_STR "Tanzania"
#define Thailand_COUNTRY_STR "Thailand"
#define Tunisia_COUNTRY_STR "Tunisia"
#define Turkey_COUNTRY_STR "Turkey"
#define United_Arab_Emirates_COUNTRY_STR "United Arab Emirates"
#define Uruguay_COUNTRY_STR "Uruguay"
#define UK_COUNTRY_STR "UK"
#define Ukraine_COUNTRY_STR "Ukraine"
#define Vatican_City_COUNTRY_STR "Vatican City"
#define Venezuela_COUNTRY_STR "Venezuela"
#define Vietnam_COUNTRY_STR "Vietnam"
#define Yemen_COUNTRY_STR "Yemen"
#define Yugoslavia_COUNTRY_STR "Yugoslavia"
#define Zaire_COUNTRY_STR "Zaire"
#define Zimbabwe_COUNTRY_STR "Zimbabwe"
#define NON_COUNTRY_FUNNY_STR "Illegal alien"
#define NON_COUNTRY_STR "Not entered"
